/*	Author: A.Voss@FH-Aachen.de
 * 
 * 	Thema Vererbung, inheritance
 */

#include <iostream>
#include <cstdlib>
using namespace std;

#include "../../include/tools.h"

class A 
{
public: 
    // kein std-ctor!
    A()		{ tools_log(); cout << "ctor A" << endl; }
    ~A()    { tools_log(); cout << "dtor A" << endl; }
};

class B : public A  					/*	public A ?
 * 
 * 	B erbt alle Eigenschaften von A und diese sind public. Genauso
 * 	moeglich sind protected und private.
 */
{
public: 
    B()		{ tools_log(); cout << "ctor B" << endl; }
    ~B()    { tools_log(); cout << "dtor B" << endl; }
};

int main()
{
    tools_log(); cout << "define objects a,b" << endl;

    // man beachte die Aufrufreihenfolge der ctors
    A a;
    B b;		

    tools_log(); cout << "define objects in scope" << endl;
	if (true) {
		A a2;
	}

    tools_log(); cout << "end of main" << endl;
    
    return EXIT_SUCCESS;
}

